/**
 * Keystore
 * Storage for secrets and keys. When a user creates and encrypts Data Encryption Keys and Keypairs, they are stored in the Keystore. A user cannot access the Vault without first using the Keystore. In the current implementation the Keystore functionality is implemented by meeco-keystore.
 *
 * The version of the OpenAPI document: 6.2.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent, HttpParameterCodec } from '@angular/common/http';
import { Observable } from 'rxjs';
import { PostKeypairsRequest } from '../model/models';
import { PutKeypairsRequest } from '../model/models';
import { Configuration } from '../configuration';
export declare class KeypairService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    encoder: HttpParameterCodec;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private addToHttpParams;
    private addToHttpParamsRecursive;
    /**
     * Retrieves a keypair by external id
     * Retrieves a KeyPair specified by &#x60;external_id&#x60; (eg the &#x60;id&#x60; for a Connection, if the KeyPair was created for that purpose).
     * @param externalId
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    keypairsExternalIdExternalIdGet(externalId: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    keypairsExternalIdExternalIdGet(externalId: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    keypairsExternalIdExternalIdGet(externalId: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Deletes a keypair
     * Deletes a keypair identified by its ID.
     * @param id
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    keypairsIdDelete(id: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    keypairsIdDelete(id: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    keypairsIdDelete(id: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Retrieves a keypair
     * Retrieves a keypair identified by its ID. The keypair encrypted with the key encryption key (KEK) of the user (field &#x60;encrypted_serialized_key&#x60;). The format is the serialization format of the Cryppo library. The public key is also served unencrypted as a PEM
     * @param id
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    keypairsIdGet(id: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    keypairsIdGet(id: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    keypairsIdGet(id: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Updates a keypair
     * Updates fields for KeyPair specified by id with new values if provided in params.
     * @param id
     * @param putKeypairsRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    keypairsIdPatch(id: string, putKeypairsRequest?: PutKeypairsRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    keypairsIdPatch(id: string, putKeypairsRequest?: PutKeypairsRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    keypairsIdPatch(id: string, putKeypairsRequest?: PutKeypairsRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Stores a keypair
     * Stores a keypair. The keypair encrypted with the key encryption key (KEK) of the user (field &#x60;encrypted_serialized_key&#x60;). The format is the serialization format of the Cryppo library. Also stores the public key unencrypted as a PEM. Each keypair can be tagged by a list of tags which make is possible for the client to differentiate between various keypairs.
     * @param postKeypairsRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    keypairsPost(postKeypairsRequest?: PostKeypairsRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    keypairsPost(postKeypairsRequest?: PostKeypairsRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    keypairsPost(postKeypairsRequest?: PostKeypairsRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
}
