/**
 * Keystore
 * Storage for secrets and keys. When a user creates and encrypts Data Encryption Keys and Keypairs, they are stored in the Keystore. A user cannot access the Vault without first using the Keystore. In the current implementation the Keystore functionality is implemented by meeco-keystore.
 *
 * The version of the OpenAPI document: 6.2.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent, HttpParameterCodec } from '@angular/common/http';
import { Observable } from 'rxjs';
import { PostSessionTimeLimitedRequest } from '../model/models';
import { PostSessionWithLoginKeyRequest } from '../model/models';
import { PostSrpSessionRequest } from '../model/models';
import { Configuration } from '../configuration';
export declare class SessionService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    encoder: HttpParameterCodec;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private addToHttpParams;
    private addToHttpParamsRecursive;
    /**
     * Deletes all user sessions
     * Deletes either (1) all user sessions (that is, access tokens), (2) or all user sessions except for the session under which the current call is being executed.
     * @param exceptCurrent if present, the current session will not be deleted. If absent, all current session will be deleted
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    sessionAllDelete(exceptCurrent?: boolean, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    sessionAllDelete(exceptCurrent?: boolean, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    sessionAllDelete(exceptCurrent?: boolean, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Deletes a session
     * Log out, deleting current Session.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    sessionDelete(observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    sessionDelete(observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    sessionDelete(observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Shows the validity of the current session
     * Shows the validity of the current session
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    sessionGet(observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    sessionGet(observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    sessionGet(observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Creates a session token valid for the specified number of seconds
     * This endpoint requires an existing session, that is, it is not strictly a login endpoint. It creates anothera new session token valid for the specified number of seconds
     * @param postSessionTimeLimitedRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    sessionLimitedInTimePost(postSessionTimeLimitedRequest?: PostSessionTimeLimitedRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    sessionLimitedInTimePost(postSessionTimeLimitedRequest?: PostSessionTimeLimitedRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    sessionLimitedInTimePost(postSessionTimeLimitedRequest?: PostSessionTimeLimitedRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Creates a session with a login key of the external party
     * A call to log in and obtain a session authentication string in the flowwith an external party. &#x60;login_key&#x60; is an identification token which will be sent to the external party for user verification.This call must be preceded by the external party calling &#x60;/admin/users&#x60; and creating a user record.
     * @param postSessionWithLoginKeyRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    sessionWithLoginKeyPost(postSessionWithLoginKeyRequest?: PostSessionWithLoginKeyRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    sessionWithLoginKeyPost(postSessionWithLoginKeyRequest?: PostSessionWithLoginKeyRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    sessionWithLoginKeyPost(postSessionWithLoginKeyRequest?: PostSessionWithLoginKeyRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Creates a session with SRP authentication
     * Creates a session using SRP (Secure Remote Password) authentication
     * @param postSrpSessionRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    srpSessionPost(postSrpSessionRequest?: PostSrpSessionRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    srpSessionPost(postSrpSessionRequest?: PostSrpSessionRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    srpSessionPost(postSrpSessionRequest?: PostSrpSessionRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
}
