/**
 * Keystore
 * Storage for secrets and keys. When a user creates and encrypts Data Encryption Keys and Keypairs, they are stored in the Keystore. A user cannot access the Vault without first using the Keystore. In the current implementation the Keystore functionality is implemented by meeco-keystore.
 *
 * The version of the OpenAPI document: 6.2.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent, HttpParameterCodec } from '@angular/common/http';
import { Observable } from 'rxjs';
import { DelegationResponse } from '../model/models';
import { UpdateDelegationsRequest } from '../model/models';
import { Configuration } from '../configuration';
export declare class SystemDelegationService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    encoder: HttpParameterCodec;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private addToHttpParams;
    private addToHttpParamsRecursive;
    /**
     * Deletes a delegation
     * Deletes a delegation identified by its token.  Only for backend to backend use.
     * @param delegationToken
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    systemDelegationsDelegationTokenDelete(delegationToken: string, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    systemDelegationsDelegationTokenDelete(delegationToken: string, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    systemDelegationsDelegationTokenDelete(delegationToken: string, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Updates a delegation
     * Updates a delegation identified by its delegation token.  Only for backend to backend use.
     * @param delegationToken
     * @param updateDelegationsRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    systemDelegationsDelegationTokenPut(delegationToken: string, updateDelegationsRequest: UpdateDelegationsRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
    }): Observable<DelegationResponse>;
    systemDelegationsDelegationTokenPut(delegationToken: string, updateDelegationsRequest: UpdateDelegationsRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
    }): Observable<HttpResponse<DelegationResponse>>;
    systemDelegationsDelegationTokenPut(delegationToken: string, updateDelegationsRequest: UpdateDelegationsRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: 'application/json';
    }): Observable<HttpEvent<DelegationResponse>>;
}
