/**
 * Keystore
 * Storage for secrets and keys. When a user creates and encrypts Data Encryption Keys and Keypairs, they are stored in the Keystore. A user cannot access the Vault without first using the Keystore. In the current implementation the Keystore functionality is implemented by meeco-keystore.
 *
 * The version of the OpenAPI document: 6.2.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { HttpClient, HttpHeaders, HttpResponse, HttpEvent, HttpParameterCodec } from '@angular/common/http';
import { Observable } from 'rxjs';
import { PostAdminUsersRequest } from '../model/models';
import { PostResellerUserCreateRequest } from '../model/models';
import { PostSrpChallengesRequest } from '../model/models';
import { PostSrpUsernameRequest } from '../model/models';
import { PostSrpUsersRequest } from '../model/models';
import { Configuration } from '../configuration';
export declare class UserService {
    protected httpClient: HttpClient;
    protected basePath: string;
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    encoder: HttpParameterCodec;
    constructor(httpClient: HttpClient, basePath: string, configuration: Configuration);
    private addToHttpParams;
    private addToHttpParamsRecursive;
    /**
     * Creates a user account
     * A Vault user account is created by the external party, this is a backend-to-backend call. In order to perform this call the external party must possess a &#x60;provider_api_key&#x60;.
     * @param postAdminUsersRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    adminUsersPost(postAdminUsersRequest?: PostAdminUsersRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    adminUsersPost(postAdminUsersRequest?: PostAdminUsersRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    adminUsersPost(postAdminUsersRequest?: PostAdminUsersRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Creates a user account
     * A Vault user account is created by the external party, this is a backend-to-backend call. In order to perform this call the external party must possess a &#x60;provider_api_key&#x60;.
     * @param postResellerUserCreateRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    portalServiceV1ResellerUserCreatePost(postResellerUserCreateRequest?: PostResellerUserCreateRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    portalServiceV1ResellerUserCreatePost(postResellerUserCreateRequest?: PostResellerUserCreateRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    portalServiceV1ResellerUserCreatePost(postResellerUserCreateRequest?: PostResellerUserCreateRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Creates a challenge for SRP user auth
     * Creates an SRP challenge to authenticate with for a given username (Secure Remote Password)
     * @param postSrpChallengesRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    srpChallengesPost(postSrpChallengesRequest?: PostSrpChallengesRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    srpChallengesPost(postSrpChallengesRequest?: PostSrpChallengesRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    srpChallengesPost(postSrpChallengesRequest?: PostSrpChallengesRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Creates a username for use with SRP auth
     * Creates a username for use on the POST /srp/users endpoint
     * @param postSrpUsernameRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    srpUsernamePost(postSrpUsernameRequest?: PostSrpUsernameRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    srpUsernamePost(postSrpUsernameRequest?: PostSrpUsernameRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    srpUsernamePost(postSrpUsernameRequest?: PostSrpUsernameRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Creates a user using SRP auth
     * Creates a user acception only SRP (Secure Remote Password) authentication
     * @param postSrpUsersRequest
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    srpUsersPost(postSrpUsersRequest?: PostSrpUsersRequest, observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    srpUsersPost(postSrpUsersRequest?: PostSrpUsersRequest, observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    srpUsersPost(postSrpUsersRequest?: PostSrpUsersRequest, observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * removes a user from queue for deletion
     * Removes the current user from the queue for asynchronous deletion.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    usersDeletionQueueDelete(observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    usersDeletionQueueDelete(observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    usersDeletionQueueDelete(observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
    /**
     * Queues a user for deletion
     * Queues the current user for asynchronous deletion.
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    usersDeletionQueuePost(observe?: 'body', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<any>;
    usersDeletionQueuePost(observe?: 'response', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpResponse<any>>;
    usersDeletionQueuePost(observe?: 'events', reportProgress?: boolean, options?: {
        httpHeaderAccept?: undefined;
    }): Observable<HttpEvent<any>>;
}
