/**
 * Keystore
 * Storage for secrets and keys. When a user creates and encrypts Data Encryption Keys and Keypairs, they are stored in the Keystore. A user cannot access the Vault without first using the Keystore. In the current implementation the Keystore functionality is implemented by meeco-keystore.
 *
 * The version of the OpenAPI document: 6.2.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
export interface Delegation {
    /**
     * The delegation token identifies the delegation relation in the keystore. The delegation token is a unique token which is generated when the account owner creates a delegation. The delegation token is then added to the invitation in the vault, and once the delegate user accepts the invitation he/she can retrieve it from the connection and use it to claim the delegation record in the keystore.
     */
    delegation_token: string;
    /**
     * Timestamp of when the delegate claimed the delegation record with `POST /delegations/{delegation_token}/claim`
     */
    claimed_at: string | null;
    /**
     * Expiration date of a delegation. Each delegation exipres after a while, and claiming an expired delegation is not possible.
     */
    expire_at: string;
    /**
     * Timestamp of when verification of a delegation took place. Verification of a delegation happens when both `delegate_signature` and `delegate_public_key` are present.`delegate_signature` is added by the delegate user when claiming the delegation record. `delegate_public_key` is a public key of the delegate user from the connection between the delegate user and the account owner in the vault, and is added by the account owner when sharing the KEK for the first time.
     */
    verification_attempted_at: string | null;
    /**
     * `true` or `false`: the result of verifying the signature of the delegate user.Verification of a delegation happens when both `delegate_signature` and `delegate_public_key` are present.`delegate_signature` is added by the delegate user when claiming the delegation record. `delegate_public_key` is a public key of the delegate user from the connection between the delegate user and the account owner in the vault, and is added by the account owner when sharing the KEK for the first time.
     */
    verified: boolean | null;
    /**
     * The delegation role identical to the delegation role in the vault connection.
     */
    delegation_role: string;
    /**
     * The public key of delegate user, this public key belongs to the connection keypair of the delegate user in the vault. It is added  by the account owner when sharing the KEK for the first time.
     */
    delegate_public_key: string | null;
    /**
     * When the delegate user claims the delegation record he/she adds an RSA signature signed with the connection keypair of the delegate user in the vault
     */
    delegate_signature: string | null;
    /**
     * ID of the account owner in the vault.
     */
    vault_account_owner_id: string | null;
    /**
     * This field specifies the current encryption mode of `account_owner_kek`.
     */
    account_owner_kek_encrypted_with_connection_keypair: boolean | null;
    /**
     * Key encryption key of the account owner stored in the delegation record for the delegate user. This KEK is initially encrypted by the public key of delegate user, this public key belongs to the connection keypair of the delegate user in the vault. This KEK is then re-encrypted with the KEK of the delegate user. Field `account_owner_kek_encrypted_with_connection_keypair` specifies the current encryption mode.
     */
    account_owner_kek: string | null;
}
